<?php
//##copyright##

if (isset($rss_id))
{
	include_once IA_INCLUDES . 'utils' . IA_DS . 'rss2array.php';

	$iaRSSFeed = $iaCore->factoryPlugin('rss_reader', iaCore::ADMIN, 'rssfeed');

	$data = $iaRSSFeed->getByRSSId($rss_id);
	$rss = array();

	if ($data)
	{
		$refresh = 1 * 60 * 60;
		if (isset($data['refresh']))
		{
			$refresh = (int)$data['refresh'];
			unset($data['refresh']);
		}
		$refresh = max(10 * 60, $refresh);

		$url = trim($data['feed_url']);

		if (!empty($url))
		{
			$filemtime = 0;
			$cache = IA_TMP . 'cache' . IA_DS . 'rss_' . md5($url) . '.inc';

			if (file_exists($cache))
			{
				$filemtime = filemtime($cache) + $refresh;
			}

			if (time() > $filemtime)
			{
				$tmp = rss2array($url);
				if (isset($tmp['items']))
				{
					$itm_cnt = count($tmp['items']); // Number of RSS items
					// Unset redundant items
					if ($itm_cnt && $itm_cnt > 5)
					{
						for ($i = 5; $i < $itm_cnt; $i++)
						{
							unset($tmp['items'][$i]);
						}
					}
					file_put_contents($cache, serialize($tmp));
				}
			}
			else
			{
				$tmp = unserialize(file_get_contents($cache));
			}

			$rss = isset($rss) && !empty($rss) ? array_merge($rss, $tmp) : $tmp;
		}
	}

	$iaCore->iaView->iaSmarty->assign('rss_reader', $rss);
	echo $iaCore->iaView->iaSmarty->fetch(IA_PLUGINS . 'rss_reader/templates/front/index.tpl');
}